#ifndef BWIDGETS_DRAW_HPP
#define BWIDGETS_DRAW_HPP

#include <cstdint>
#include <functional>
#include <memory>

struct SDL_PixelFormat;
struct SDL_Point;

namespace bwidgets
{
    class Color;
    class Renderer;
    class Texture;

    [[nodiscard]] auto aa(Color, int, float) noexcept -> Color;
    [[nodiscard]] auto filled_circle(Color, int resolution, Renderer*, int aa_pixels = 3)
      -> std::shared_ptr<Texture>;
    void set_pixels_color(Texture*,
                          std::function<uint32_t(SDL_Point, const SDL_PixelFormat*)>);
}

#endif
