#ifndef BWIDGETS_EVENT_HANDLER_HPP
#define BWIDGETS_EVENT_HANDLER_HPP

#include <functional>
#include <utility>

#include <SDL_events.h>

namespace bwidgets
{
    class EventHandler
    {
    public:
        using handler_t =
          std::pair<SDL_EventType, std::function<void(const SDL_Event&)>>;

    protected:
        EventHandler() = default;

    public:
        EventHandler(const EventHandler&) = delete;
        EventHandler(EventHandler&&)      = delete;
        auto operator=(const EventHandler&) -> EventHandler& = delete;
        auto operator=(EventHandler&&) -> EventHandler& = delete;

        virtual ~EventHandler() = default;

        virtual void handle_event(const SDL_Event&) = 0;
    };
}

#endif
