#ifndef BWIDGETS_MOUSE_HANDLER_HPP
#define BWIDGETS_MOUSE_HANDLER_HPP

#include <basic_widgets/w/feat/event_handler.hpp>
#include <basic_widgets/w/feat/focus_handler.hpp>

struct SDL_MouseButtonEvent;
struct SDL_MouseMotionEvent;

namespace bwidgets
{
    class MouseHandler : virtual public FocusHandler,
                         virtual public EventHandler
    {
    protected:
        using EventHandler::EventHandler;

        virtual void _on_push(bool) = 0;

    public:
        virtual void click_handler(std::function<void(const SDL_MouseButtonEvent&)>) = 0;
        virtual void disable_mouse_handler()                                         = 0;
        virtual void enable_mouse_handler(const SDL_Rect*, const SDL_Rect*)          = 0;
        [[nodiscard]] virtual bool hovered() const                                   = 0;
        virtual void
        mouse_motion_handler(std::function<void(const SDL_MouseMotionEvent&)>) = 0;
        [[nodiscard]] virtual bool pushed() const                              = 0;
    };
}

#endif
