#include <basic_widgets/w/base/widget.hpp>

using namespace bwidgets;

auto Widget::render() -> Widget*
{
    if (_renderer == nullptr) return this;

#ifdef BWIDGETS_DEBUG
    _renderer
      ->draw_color({
  // NOLINTNEXTLINE(readability-magic-numbers)
        {0, 255, 0, SDL_ALPHA_OPAQUE}
    })
      ->draw_rect(nullptr);
#endif

    _renderer->viewport(_viewport);
    _handle_rendering();

    return this;
}

auto Widget::renderer(std::shared_ptr<Renderer> r) -> Widget*
{
    if (r != _renderer) {
        _handle_renderer_change(r);
        _renderer = r;
    }
    return this;
}

auto Widget::viewport(const SDL_Rect& vp) -> Widget*
{
    _handle_geometry_change(vp);
    _viewport = vp;
    return this;
}

auto Widget::viewport() const -> const SDL_Rect&
{
    return _viewport;
}
